// GINLinePR.mq4
//   
//------------------------------------
#property indicator_separate_window
//-----------------------------------------
//#property indicator_minimum -1
//#property indicator_maximum 1
//-----------------------------------------
#property indicator_buffers 1
//#property indicator_buffers 2//==
//-------------------------------------------
#property indicator_color1 Gold
#property indicator_style1 STYLE_SOLID // STYLE_SOLID STYLE_DOT
#property indicator_width1 3
//#property indicator_color2 Red//==
//#property indicator_style2 STYLE_SOLID//==
//#property indicator_width2 2//==
//-----------
//#property indicator_level1 0.6
//#property indicator_level2 0
//#property indicator_level3 -0.6
//#property indicator_levelstyle STYLE_DASH

//----    ---- input parameters -----------------
extern int GINperiod   =  9;
//extern int MAperiod = 4//==
//extern int MAmetod = MODE_SMA //== 0-MODE_SMA 1-MODE_EMA 2-MODE_SMMA 3-MODE_LWMA

//-----   ---------- buffers ----------------------------
double GINBuffer[]; //
//double MABuffer[];//==

// -----   ----------- initialization function ---
int init()
{
string short_name;
//----  
   SetIndexStyle(0,DRAW_LINE);
//SetIndexStyle(1,DRAW_LINE);//==
  SetIndexDrawBegin(0,GINperiod);
//SetIndexDrawBegin(1,MAperiod);//==
//IndicatorDigits(Digits+1);//--
//----      ----  indicator buffers mapping
   SetIndexBuffer(0, GINBuffer);
//SetIndexBuffer(1, MABuffer);//==
//------------      ---------------------------
  // short_name="GINLinePR("+GINperiod+")";
short_name="GINLinePR("+GINperiod+")";//--
//short_name="GINLinePR("+GINperiod+","+MAperiod+")";//==
//short_name="GINLinePR("+GINperiod+","+MAperiod+","+MAmetod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//SetIndexLabel(1,"GIN_Signal");//--
//----
   
return(0);
}

//===========================   ======================================
int start()
{
int limit;
int counted_bars=IndicatorCounted();
double Value=0,Value1=0,GIN=0; //
double price;
double MinL=0;
double MaxH=0;
// double OpPr=0;
//----   -----   initial zero ------
   if(counted_bars>1) counted_bars--; //if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
// -----------   ---------------
   for(int i=0; i<limit; i++)
   {
      MaxH  = High[iHighest(NULL,0,MODE_HIGH,GINperiod,i)]; //       period
      MinL  = Low[iLowest(NULL,0,MODE_LOW,GINperiod,i)];   //       period
      // OpPr = Open [iOpen(NULL,0,MODE_OPEN,period,i)]; //   ()
      price = (High[i]+Low[i])/2;  //      iOpen
   // price = (High[i]+Low[i])/2;
   
      if(MaxH-MinL == 0) Value = 0.33*2*(0-0.5) + 0.67*Value1; 
   // if(MaxH-MinL == 0) Value = 0.33*2*(0-0.5) + 0.67*Value1;
   
      else Value = 0.33*2*((price-MaxH)/(MinL-MaxH)-0.5) + 0.67*Value1; 
   // else Value = 0.33*2*((price-MaxH)/(MinL-MaxH)-0.5) + 0.67*Value1;

      Value=MathMin(MathMax(Value,-0.999),0.999);

      if(1-Value == 0) GINBuffer[i]=(0.5+0.5*GIN)*(-1);
      else GINBuffer[i]=(0.5*MathLog((1+Value)/(1-Value))+0.5*GIN)*(-1);

      Value1=Value;
      GIN=GINBuffer[i];
//---- signal line counted in the 2-nd buffer --   ------ == 
//for(i=0; i<limit; i++)//--
//MABuffer[i]=iMAOnArray(GINBuffer,Bars[i],MAperiod,0,MAmetod,i);//--
   }

return(0);
}